/* Prototypes for assembler functions called in lhmain.c 
 * Most of the functions are just simple interfaces to the int 21h API.
 */

int     execute(void);
int     createChildPSP(WORD pspSeg, WORD nextMem);

/* DOS file functions */
WORD    DosOpen(char far *name, WORD mode);          /* DOS func. 3dh */
void    DosClose(WORD handle);                       /* DOS func. 3eh */
DWORD   DosSeek(WORD handle, DWORD offs, int fromwh);/* DOS func. 42h */
WORD    DosRead(WORD handle, void far *buf, WORD nbytes);/* DOS func. 3fh */

/* Memory allocation functions */
WORD    DosAlloc(WORD paragraphs);
WORD    DosSetStrategy(WORD strat);                  
int     DosSetUMBLink(int value);
int     DosResize(WORD block, WORD newSize);         /* DOS func. 4ah */
void    DosFree(WORD block);                         /* DOS func. 49h */

/* file searching related functions */
void    DosSetDTA(void far *dta);                    /* DOS func. 1ah */
int     DosFindFirst(char far *name, WORD mask);     /* DOS func. 4eh */
char    DosGetCurrDrive(void);                       /* DOS func. 19h */
int     DosGetCurrDir(int drive, char far *buf);     /* DOS func. 47h */
WORD    GetFirstMCB(void);

int     DosLoadOverlay(char far *fname, struct LoadOverlay far *lo);
BYTE    DosParseFCB(char far *str, struct FCB far *fcb); /* DOS func. 29h */
WORD    getCurrentPSP();                             /* DOS func. 62h */
void    DosStrupr(char far *string);                 /* DOS func. 6522h */

void    farmemcpy(void far *dest, void far *src, size_t nbytes);
int     farmemcmp(void far *s1, void far *s2, size_t nbytes);
int     dos_error;  /* Global variable that holds the most recent DOS error */

